'
' BASIC.bas
'
' Demo/prototype of a "quick & easy" BASIC IDE based upon the VT2000
' standard
'
' It would be an editor just working with text "graphics", if you hit
' "Run" (F10), the project will be saved, compiled and executed. The
' "Direct" Mode is ment for direct execution of single BASIC instructions,
' therefore testing. The output canvas of "Run" might be manipulated too.
'

#INCLUDE "retrogra.bi"

FUNCTION N(text AS STRING) AS STRING
  RETURN PRINTCOLOR(240,215)+text
END FUNCTION
FUNCTION K(text AS STRING) AS STRING
  RETURN PRINTCOLOR(3,215)+text
END FUNCTION
FUNCTION F(text AS STRING) AS STRING
  RETURN PRINTCOLOR(15,215)+text
END FUNCTION
FUNCTION S(text AS STRING) AS STRING
  RETURN PRINTCOLOR(54,215)+text
END FUNCTION
FUNCTION T(text AS STRING) AS STRING
  RETURN PRINTCOLOR(180,215)+text
END FUNCTION
FUNCTION C(text AS STRING) AS STRING
  RETURN PRINTCOLOR(198,215)+text
END FUNCTION
FUNCTION V(text AS STRING) AS STRING
  RETURN PRINTCOLOR(86,215)+text
END FUNCTION

DECLARE SUB redraw
DIM AS INTEGER i, m, mx, my, mb
DIM AS BOOLEAN overwrite, show
DIM AS STRING key, dstr
DIM shared AS STRING*16 menu(20)={"Save","Merge","New","Quit","Menu","Release","Help","Hide|Show","Direct","Run","Load","Export","Close","Cl. All","Disable|Enable","Debug","Config","Insert|Overwr.","Flip",_
"Test"}

rgSCREENNEW

redraw

m=0
rgPRINT PRINTCOLOR(240,215)
DO
  rgGETMOUSE mx, my, , mb
  key=rgINKEY()
  IF mb=1 THEN ' mouse click
    IF my<32 THEN ' inside menu
      m=((mx-4) SHR 6) ' each entry is 64 bits broad, border is in the middle of the pipes
      IF m<0 THEN m=0
      IF my>15 THEN
        m+=10
      ENDIF
      m+=1 ' <>0 means menu entry selected
    ENDIF
  ENDIF

  IF key>"" THEN
    i=ASC(key)
    IF i>239 AND i<250 THEN ' function key F1-F10
      ' highlight menu entry
      i-=240
      IF rgSHIFTKEYS(255)=SHIFT THEN i+=10
      m=i+1
    ELSE
      ' other keys
    ENDIF
  ENDIF
  IF m THEN
    m-=1
    dstr=menu(m)
    i=INSTR(dstr, "|")
    IF i THEN
      dstr=LEFT(dstr, i-1)
    ENDIF
    i=LEN(dstr)
    IF i<6 THEN
      dstr=SPACE((7-i) SHR 1)+dstr+SPACE((8-i) SHR 1)
    ELSEIF i=6 THEN
      dstr+=" "
    ENDIF
    IF m=9 OR m=19 THEN dstr=LEFT(dstr,6)
    IF m>9 THEN
      i=((m-10) SHL 3)+2
      rgPRINT AT(i,2)+dstr
    ELSE
      i=(m SHL 3)+2
      rgPRINT AT(i,1)+dstr
    ENDIF
    rgSCREENSHOW

    ' execute menu entry
    SELECT CASE m
      CASE 0
        IF rgSHIFTKEYS(255)=SHIFT THEN
        ELSE
        ENDIF
      CASE 1
      CASE 2
      CASE 3
        IF rgSHIFTKEYS(255)=SHIFT THEN
        ELSE
          EXIT DO
        ENDIF
      CASE 4
        IF rgSHIFTKEYS(255)=SHIFT THEN
        ELSE
        ENDIF
      CASE 5
      CASE 6
      CASE 7
      CASE 8
      CASE 9
    END SELECT
    FOR i=1 TO 25
      SLEEP 10
      RGSCREENSHOW
    NEXT

    IF m>9 THEN
      i=((m-10) SHL 3)+2
      rgPRINT AT(i,2)+ESC("A")+dstr+ESC("a")
    ELSE
      i=(m SHL 3)+2
      rgPRINT AT(i,1)+ESC("A")+dstr+ESC("a")
    ENDIF
    m=0
  ENDIF
  SLEEP 10
  rgSCREENSHOW
LOOP

SLEEP 250
rgSCREENDELETE
END

SUB REDRAW
  DIM AS INTEGER i, m
  DIM AS STRING dstr

  rgPRINT ESC("A")
  FOR m=0 TO 19
    dstr=menu(m)
    i=INSTR(dstr, "|")
    IF i THEN
      dstr=LEFT(dstr, i-1)
    ENDIF
    i=LEN(dstr)
    IF i<6 THEN
      dstr=SPACE((7-i) SHR 1)+dstr+SPACE((8-i) SHR 1)
    ELSEIF i=6 THEN
      dstr+=" "
    ENDIF
    rgPRINT "|"+dstr
    IF m=9 OR m=19 THEN rgPRINT CHR(3)+"|" ' 1 left
  NEXT

  ' file tabs
  rgPRINT AT(1,3)+SPACE(80)+ESC("a") ' black row, end menu block

  RGPRINT AT(1,3)+PRINTCOLOR(86,240)+CHR(26,35)
  RGPRINT PRINTCOLOR(43,86)
  RGPRINT CHR(27,65,26,56,27,97)+"main.bas"+chr(27,65,26,57,27,97)
  RGPRINT CHR(27,65,26,56,27,97)+"extend.bi"+chr(27,65,26,57,27,97)
  RGPRINT PRINTCOLOR(240,215)
  RGPRINT CHR(27,65,26,56,27,97)+"retrogra.bi"+chr(27,65,26,57,27,97)
  RGPRINT PRINTCOLOR(240,215)

  ' source code area
  RGPRINT AT(1,4)+PRINTCOLOR(5,2)+CHR(26,33)+K("SUB ")+F("rgcSETPIXEL")+N("(")+k("BYVAL ")+S("vout ")+K("AS ")+T("BYTE PTR")+N(", ")+T("BYVAL ")+S("colour ")+K("AS ")+T("UBYTE)")

  RGPRINT AT(1,5)+K("SUB ")+F("rgcREFRESH")

  RGPRINT AT(3,6)+C("' puts out the whole console content, based on its char buffer")

  RGPRINT AT(3,7)+K("DIM AS ")+T("UBYTE PTR ")+S("vout")+N(", ")+S("cdp")

  RGPRINT AT(3,8)+K("DIM AS ")+T("INTEGER ")+S("x")+N(", ")+S("y")+N(", ")+S("lo")+N("=")+V("0")+N(", ")+S("ls")+N(", ")+S("i")+N(", ")+S("j")
  '
  RGPRINT AT(3,10)+S("vout")+N("=")+F("SCREENPT")+PRINTCOLOR(130,240)+"R"

  RGPRINT AT(3,11)+S("lo")+N("=")+S("retrogra_cwidth")

  RGPRINT AT(3,12)+S("lo")+N("-=")+V("8 ")+C("' offset to next line (after printing 8 pixels)")

  RGPRINT AT(3,14)+K("FOR ")+S("y")+N("=")+V("0 ")+K("TO ")+V("29")

  RGPRINT AT(3,15)+PRINTCOLOR(173,215)+UTF8(9482,32)
  RGPRINT K("FOR ")+S("y")+N("=")+V("0 ")+K("TO ")+V("79")

  RGPRINT AT(3,16)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)
  RGPRINT K("IF ")+S("rgccell")+N("(")+S("x")+N(",")+S("y")+N(").")+S("flags ")+K("THEN ")+C("' character to print")

  rgPRINT AT(3,17)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT S("i")+N("=")+V("16")

  RGPRINT AT(3,18)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  RGPRINT K("WHILE ")+S("i")

  RGPRINT AT(3,19)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  RGPRINT S("i")+N("-=")+V("1")

  RGPRINT AT(3,20)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  RGPRINT S("cfl")+N("=")+F("PEEK")+N("(")+T("UBYTE")+N(", ")+S("cdp")+N(")")

  rgPRINT AT(3,21)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  rgPRINT S("j")+N("=")+V("8")

  rgPRINT AT(3,22)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  rgPRINT K("WHILE ")+S("j")

  rgPRINT AT(3,23)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)
  rgPRINT S("j")+N("-=")+V("1")

  rgPRINT AT(3,24)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)
  rgPRINT K("IF ")+N("(")+S("cfl ")+K("AND ")+V("1")+N(") ")+K("THEN ")+C("' foreground pixel")

  RGPRINT AT(3,25)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)
  rgPRINT K("IF ")+S("fgcolour")+N("<")+V("240 ")+K("THEN")

  RGPRINT AT(3,26)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)+PRINTCOLOR(173,215)+UTF8(9482,32)
  RGPRINT N("*")+S("vout")+N("=")+S("fgcolour")

  RGPRINT AT(3,27)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)
  RGPRINT K("ELSE")

  RGPRINT AT(3,28)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)+PRINTCOLOR(173,215)+UTF8(9482,32)
  RGPRINT F("rgcSETPIXEL")+N("(")+S("vout")+N(", ")+S("fgcolour")+N(")")

  rgPRINT AT(3,29)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)
  rgPRINT K("ENDIF")

  rgPRINT AT(3,30)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)
  rgPRINT K("ELSE ")+C("' background pixel")

  rgSCREENSHOW
END SUB

